(function( $ ) {

	function sse_dispatch_coupons() {

		/**
		 * Setting options for the jquery.datetimepicker.js plugin.
		 */
		$( document.body ).on( 'wc-init-datepickers', function() {
			$.ajax({
				type: 'POST',
				url: window.ajaxurl,
				dataType: 'json',
				data: {
					action: 'sse_dispatch_coupons',
					nonce: window.sse_disp_coupon_data.nonce
				},
				success: function( response ) {
					$.datetimepicker.setLocale( response.local );
					$( '.sse-datetime-picker, .sse-datetime-picker-notices' ).datetimepicker({
						formatTime: 'HH:mm',
						step: Number(response.step_time),
						dayOfWeekStart: 1,
						format: response.format,
						inline: false
					});
				}
			});
		}).trigger( 'wc-init-datepickers' );

		/**
		 * Assigning the value of the UTC time point to the date_dispatch_email_u option
         * change the date_dispatch_email option.
		 */
		$( '.sse-datetime-picker' ).change(function() {
			var momentDate = window.moment($( '.sse-datetime-picker' ).val());
			var jsDate = momentDate.format('X');
			$( '.sse-datetime-picker-u' ).val(jsDate);
		});

		/**
		 * Assign the value of the UTC time point to the date_dispatch_notices_u
		 * option when changing the date_dispatch_notices option.
		 */
		$( '#dcp_date_dispatch_notices_sse' ).change(function() {
			var momentDate = window.moment($( '#dcp_date_dispatch_notices_sse' ).val());
			var jsDate = momentDate.format('X');
			$( '#dcp_date_dispatch_notices_u_sse' ).val(jsDate);
		});

		/**
		 * Change the value of the field for the example in the settings when changing the date localization.
		 */
		$( '#woocommerce_date_format_calendar, #woocommerce_localization_calendar' ).change(function() {
			var lng = window.moment().locale($( '#woocommerce_localization_calendar' ).val());
			$( '#woocommerce_date_example_calendar' ).text(lng.format($( '#woocommerce_date_format_calendar' ).val()));
		});

		/**
		 * Change the value of the field for the example in the settings when changing the date format.
		 */
		window.moment.locale($( '#woocommerce_localization_calendar' ).val());
		$( '#woocommerce_date_example_calendar' ).text(window.moment().format($( '#woocommerce_date_format_calendar' ).val()));


	    /**
	     * Assign the value of the UTC time point to the date_dispatch_notices_u option when
	     * changing the date_dispatch_notices option.
		 */
		$( '.dcp_start_date_sse' ).live('change',function() {
			var momentDate = window.moment($( this ).val());
			var jsDate = momentDate.format('X');
			$( this ).closest('div').children().children('.dcp_start_date_sse_u').val(jsDate);
		});

		$( '.dcp_end_date_sse' ).live('change',function() {
			var momentDate = window.moment($( this ).val());
			var jsDate = momentDate.format('X');
			$( this ).closest('div').children().children('.dcp_end_date_sse_u').val(jsDate);
		});

		$('#dcp_notices_status_sse').prop('disabled',true);

	}

	/*
	 * Load events.
	 */
	$( document ).ready(sse_dispatch_coupons());
})( jQuery );