(function( $ ) {

	function sse_dispatch_coupons_all() {

		/*
		 * Confirmation of sending notifications to the user's account.
		 */
		$( 'button.sse_ok_notices_dispatch' ).on( 'click', function() {
			$.ajax({
				type: 'POST',
				url: window.ajaxurl,
				dataType: 'json',
				data: {
					action: 'sse_ok_notices_dispatch',
					nonce: window.sse_disp_coupon_data.nonce,
					idCoupon: $( 'button.sse_ok_notices_dispatch' ).data( 'idCoupon' ),
					userID: $( 'button.sse_ok_notices_dispatch' ).data( 'userId' ),
					notifAct: 'add'
				},
				success: function() {
					location.reload();
				}
			});
		});


		/*
		 * Cancel sending notifications to the user's account.
		 */
		$( 'button.sse_no_notices_dispatch' ).on( 'click', function() {
			$.ajax({
				type: 'POST',
				url: window.ajaxurl,
				dataType: 'json',
				data: {
					action: 'sse_no_notices_dispatch',
					nonce: window.sse_disp_coupon_data.nonce,
					idCoupon: $( 'button.sse_no_notices_dispatch' ).data( 'idCoupon' ),
					userID: $( 'button.sse_no_notices_dispatch' ).data( 'userId' ),
					notifAct: 'add'
				},
				success: function() {
					location.reload();
				}
			});
		});


		/*
		 * Confirm that you want to delete notifications in your user account.
		 */
		$( 'button.sse_ok_notices_del' ).on( 'click', function() {
			$.ajax({
				type: 'POST',
				url: window.ajaxurl,
				dataType: 'json',
				data: {
					action: 'sse_ok_notices_dispatch',
					nonce: window.sse_disp_coupon_data.nonce,
					idCoupon: $( 'button.sse_ok_notices_del' ).data( 'idCoupon' ),
					userID: $( 'button.sse_ok_notices_del' ).data( 'userId' ),
					notifAct: 'del'
				},
				success: function() {
					location.reload();
				}
			});
		});


        /*
		 * Undo delete notifications in the user's account.
		 */
		$( 'button.sse_no_notices_del' ).on( 'click', function() {
			$.ajax({
				type: 'POST',
				url: window.ajaxurl,
				dataType: 'json',
				data: {
					action: 'sse_no_notices_dispatch',
					nonce: window.sse_disp_coupon_data.nonce,
					idCoupon: $( 'button.sse_no_notices_del' ).data( 'idCoupon' ),
					userID: $( 'button.sse_no_notices_del' ).data( 'userId' ),
					notifAct: 'del'
				},
				success: function() {
					location.reload();
				}
			});
		});


		/*
		 * Close the window with the notification about the error of sending notifications.
		 */
		$( 'button.sse_no_notices_err' ).on( 'click', function() {
			$.ajax({
				type: 'POST',
				url: window.ajaxurl,
				dataType: 'json',
				data: {
					action: 'sse_no_notices_dispatch',
					nonce: window.sse_disp_coupon_data.nonce,
					idCoupon: $( 'button.sse_no_notices_err' ).data( 'idCoupon' ),
					userID: $( 'button.sse_no_notices_err' ).data( 'userId' ),
					notifAct: 'err',
					errStatus:  $( 'button.sse_no_notices_err' ).data( 'errStatus' )
				},
				success: function() {
					location.reload();
				}
			});
		});

		/*
		 * Delete all messages to the administrator.
		 */
		$('#DCP_AllDelAdminNotif_SSE').click(function(){
			$.ajax({
				type: 'POST',
				url: window.ajaxurl,
				dataType: 'json',
				data: {
					action: 'sse_all_del_admin_notif_dcp',
					nonce: window.sse_disp_coupon_data.nonce
				},
				success: function( response ) {
					location.reload();
				}
			});

		});

	}

	/*
	 * Load events.
	 */
	$( document ).ready(sse_dispatch_coupons_all());
})( jQuery );