<?php
/**
 * Create a menu item in the Admin panel.
 * Creating the plugin settings.
 *
 * @package  Giveaways for woocommerce/Classes
 * @author   Sindyakin Sergei
 * @version 1.0.0
 */

if (!defined('ABSPATH')) {
  exit;
}

class DCP_ADMIN_PANEL {
   /**
	 * Hook in ajax handlers.
	 */
  public static function init () {
    add_filter('woocommerce_get_settings_pages', array(__CLASS__, 'admin_panel_dispatch_coupons'), 11);
    add_action('woocommerce_admin_field_label_dcp', array(__CLASS__, 'admin_options_label_dcp'), 10);
    add_action('woocommerce_admin_field_button_dcp', array(__CLASS__, 'admin_options_button_dcp'), 10);
    add_action( 'admin_menu', array(__CLASS__, 'dcp_users_admin_menu_sse'), 12 );
  }

    /**
     * Create a menu for managing tariff plans.
     */
    function dcp_users_admin_menu_sse() {
        	add_menu_page(
    			__('Giveaways WC', 'giveaways-for-woocommerce'),
    			__('Giveaways WC', 'giveaways-for-woocommerce'),
    			'manage_options',
    			'dcp-freemius-sse',
    			array(__CLASS__, 'dcp_freemius_page_fnc_sse'),
    			'dashicons-update',
    			85
    		);
    }

/**
 * Create a page describing the plugin.
 */
function dcp_freemius_page_fnc_sse() {

$gn_head  ='<h2>' . __('Main task', 'giveaways-for-woocommerce') . '</h2>';

$gn_txt_gen = '';
$gn_txt_arr = array();

$gn_txt_arr[] = __('The main task of the "Giveaways for woocommerce" plugin is the individual dispatch of information about coupons for each user in their personal cabinets.', 'giveaways-for-woocommerce');

$gn_txt_arr[] = __('Possibility: Creation in the personal cabinet of each user of an individual list (item "Notices about coupons") of colorful notifications of coupons that he can use; Deleting unnecessary notifications from the list by each user independently.', 'giveaways-for-woocommerce');

$gn_txt_arr[] = __('Possibility(premium): Using ready-made queries and logical operations on them, you can analyze the sales individually for each user and, based on this analysis, encourage or stimulate users using coupons;
                    Output of sales information for each user in separate columns in the table with users in accordance with the conditions to be set.', 'giveaways-for-woocommerce');

 for ($i = 0; $i < count($gn_txt_arr); $i++)
  {
    $gn_txt_p = $gn_txt_arr[$i];

$gn_txt = <<<EOT
    <p class="frm_description">$gn_txt_p</p>
EOT;

    $gn_txt_gen = $gn_txt_gen . $gn_txt;
  }

    echo $gn_head . $gn_txt_gen . '</br>';

//---------------------------------------------------------------------------------


$head  ='<h2>' . __('Сustomizing  the plugin', 'giveaways-for-woocommerce') . '</h2>';

$fr_set_gen = '';
$fr_set_arr = array();

$fr_url_set1 = admin_url( 'admin.php?page=wc-settings&tab=dispatch_coupons' );
$fr_link_set1 = '<a href="' . $fr_url_set1 . '"> go over </a>';
$fr_set_arr[] = sprintf(__( 'Step 1: Customizing for admin panels (manager):
    Calendar localization, date and time format and time step; Additional columns for the coupon table (WooCommerce-> Options -> "Coupon Notifications" -> Administrator).
    Or simply activate the default settings by clicking the "Save Changes" button. %1$s', 'giveaways-for-woocommerce'), $fr_link_set1 );

$fr_url_set2 = admin_url( 'admin.php?page=wc-settings&tab=dispatch_coupons&section=notices' );
$fr_link_set2 = '<a href="' . $fr_url_set2 . '"> go over </a>';
$fr_set_arr[] = sprintf(__( 'Step 2: Customizing the appearance of notifications in the users` personal account: The quantity of notifications to be loaded at a time; Background color, borders and indents;
        The title text, its design; Registration of the delete button; Registration of the button for loading the following notifications.
        For the title, you can use a shortcode "dcp_date" (date format - PHP standard, See the table "Shortcode options" dcp_date "" in the "Additional information".
        Example: <code>&lt;span style="color:red"&gt;Coupon from &lt;/span&gt; [dcp_date local="default" format="F j, Y, g:i a"]</code>) that to specify the date and time of the notification distribution (WooCommerce-> Options -> "Coupon Notifications" -> User).
        Or simply activate the default settings by clicking the "Save Changes" button. %1$s', 'giveaways-for-woocommerce'), $fr_link_set2 );

   for ($i = 0; $i < count($fr_set_arr); $i++)
  {
    $fr_set_p = $fr_set_arr[$i];

$fr_set = <<<EOT
    <p class="frm_description">$fr_set_p</p>
EOT;

    $fr_set_gen = $fr_set_gen . $fr_set;
  }

    echo $head . $fr_set_gen  . '</br>';
//---------------------------------------------------------------------------------

$head  ='<h2>' . __('Working with the "free" version of the plugin', 'giveaways-for-woocommerce') . '</h2>';

$fr_txt_gen = '';
$fr_txt_arr = array();

$fr_txt_arr[] = __( '<u>Add and update notifications</u>', 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( 'Step 1: Add a new one or open an existing coupon, set the necessary parameters and go to the "Notification distribution" tab.'
        , 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( 'Step 2: Check the box "Notification".', 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( '<i>Note : The "Full Clear" checkbox is an auxiliary function for repeated mailing, when installed, the plugin will necessarily check for the availability of this coupon from all users.
        Otherwise, the plug-in decides to check all users or only users from the existing mailing list.</i>', 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( 'Step 3: Dial a colorful notification for distribution in the editor. You can use the shortcode "dcp_cuser" (Example: <code> [dcp_cuser data = "first_name"] </code>)
to specify the user parameters (name, surname, ...) to which the notification will be addressed (see table "Shortcode options "dcp_cuser" "in the" Additional Information "section).', 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( 'Step 4: In the "Email Users" field, you must specify a comma between email users who you want to send notifications about coupons.
If the field is left blank, the notification will be sent to all users who have the role of "client".',
    'giveaways-for-woocommerce');

$fr_txt_arr[] = __( 'Step 5: To run the command "Publish" («Update»).',  'giveaways-for-woocommerce');

$fr_txt_arr[] = __( 'Step 6: In the notification window that appears for the administrator, confirm or cancel the distribution of notifications to users.',  'giveaways-for-woocommerce');

$fr_txt_arr[] = __( '<i>Note: In case of updates, the notification, in the lists of the respective users, is moved to the top.</i>',
    'giveaways-for-woocommerce');

$fr_txt_arr[] = '</br>';



$fr_txt_arr[] = __( '<u>Setting a task to add and update notifications</u>', 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( 'Step 1: Add a new one or open an existing coupon, set the necessary parameters and go to the "Notification distribution" tab.'
        , 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( 'Step 2: Check the box "Notification". The "Full Clear" checkbox is an auxiliary function for repeated mailing, when installed, the plugin will necessarily check for the availability of this coupon from all users.
         Otherwise, the plug-in decides to check all users or only users from the existing mailing list.', 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( 'Step 3: Check "CRON" and specify the date and time of the planned mailing.', 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( 'Step 4: Dial a colorful notification for distribution in the editor. You can use the shortcode "dcp_cuser" (Example: <code> [dcp_cuser data = "first_name"] </code>)
to specify the user parameters (name, surname, ...) to which the notification will be addressed (see table "Shortcode options "dcp_cuser" "in the" Additional Information "section).', 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( 'Step 5: In the "Email Users" field, you must specify a comma between email users who you want to send notifications about coupons.
If the field is left blank, the notification will be sent to all users who have the role of "client".',
    'giveaways-for-woocommerce');

$fr_txt_arr[] = __( 'Step 6: To run the command "Publish" («Update»).',  'giveaways-for-woocommerce');

$fr_txt_arr[] = __( 'Step 7: In the notification window for the administrator, confirm or cancel the setting of the "CRON" task to send notifications to users.',  'giveaways-for-woocommerce');

$fr_txt_arr[] = '</br>';



$fr_txt_arr[] = __( '<u>Delete notification (1 way)</u>', 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( 'Step 1: Open the corresponding coupon and uncheck "Notification"".', 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( 'Step 2: To run the command "Publish" («Update»).',  'giveaways-for-woocommerce');

$fr_txt_arr[] = __( 'Step 3: In the notification window that appears for the administrator, confirm or cancel deletion of notifications to users.',  'giveaways-for-woocommerce');

$fr_txt_arr[] = '</br>';



$fr_txt_arr[] = __( '<u>Delete notification (2 way)</u>', 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( 'Step 1: Delete matching coupon.', 'giveaways-for-woocommerce');


 for ($i = 0; $i < count($fr_txt_arr); $i++)
  {
    $fr_txt_p = $fr_txt_arr[$i];

$fr_txt = <<<EOT
    <p class="frm_description">$fr_txt_p</p>
EOT;

    $fr_txt_gen = $fr_txt_gen . $fr_txt;
  }

    echo $head . $fr_txt_gen . '</br>';

//----------------------------------------------------------------------------------------------------

$head  ='<h2>' . __('Working with the "preemium" version of the plugin', 'giveaways-for-woocommerce') . '</h2>';

$fr_txt_gen = '';
$fr_txt_arr = array();

$fr_txt_arr[] = __( '<u>Add and update notifications (Single-Operative filling of the main list of users)</u>', 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( 'Step 1: Add a new one or open an existing coupon, set the necessary parameters and go to the "Notification distribution" tab.'
        , 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( 'Step 2: Check the box "Notification".', 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( '<i>Note: The "Full Clear" checkbox is an auxiliary function for repeated mailing, when installed, the plugin will necessarily check for the availability of this coupon from all users.
    Otherwise, the plug-in decides to check all users or only users from the existing mailing list.</i>', 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( 'Step 3: Dial a colorful notification for distribution in the editor. You can use the shortcode "dcp_cuser" (Example: <code> [dcp_cuser data = "first_name"] </code>)
to specify the user parameters (name, surname, ...) to which the notification will be addressed (see table "Shortcode options "dcp_cuser" "in the" Additional Information "section).', 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( 'Step 4: Go to the "user`s Filter" tab.', 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( 'Step 5: Click the "Add Filter" button.', 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( 'Step 6: Select one of the filters in the list that appears (The list of available filters with descriptions, see the table "Filter description" in the section "Additional information").', 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( '<i>Note: You can get more information about a particular filter from the special help, by clicking on the button with the question mark next to the list of filters.
    Nearby there is a button for deleting the filter, if you want to close it.</i>', 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( 'Step 7: Specify the required parameters in the appeared filter fields.', 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( 'Note: If you want to perform a group operation with filters, then set the corresponding group operation in the "Logical operation" field and repeat steps 5-7."', 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( 'Step 8: Click the "Merge" button. After that, the corresponding users will appear in the main list.', 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( '<i>Note: You can delete some of them, if necessary, by checking the corresponding checkboxes and executing the delete command.</i>'
, 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( 'Step 9: To run the command "Publish" («Update»).',  'giveaways-for-woocommerce');

$fr_txt_arr[] = __( 'Step 10: In the notification window that appears for the administrator, confirm or cancel the distribution of notifications to users.',  'giveaways-for-woocommerce');

$fr_txt_arr[] = __( '<i>Note: In case of updates, the notification, in the lists of the respective users, is moved to the top.</i>',
    'giveaways-for-woocommerce');

$fr_txt_arr[] = '</br>';



$fr_txt_arr[] = __( '<u>Add and update notifications (Multi- Operative filling of the main list of users)</u>', 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( '<i>ПNote: If you want to get a more complex filter result, you can use special operations ("Merge", "Intersect", "Exclude", "Reverse Exception", "Exclusive OR".)
    For more information, see the table "Operations with the main user list "in the" Additional Information" section) to work with the main list of users.</i>', 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( 'Step 1-8: Similar to steps 1-8 in the section "Adding and updating notifications (Single-Operative filling of the main list of users)".'
        , 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( 'Step 9: Delete the previous filter.', 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( 'Step 10: Click the "Add Filter" button.', 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( 'Step 11: Select one of the filters in the list that appears (The list of available filters with descriptions, see the table "Filter description" in the section "Additional information").', 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( '<i>Note: You can get more information about a particular filter from the special help, by clicking on the button with the question mark next to the list of filters.
    Nearby there is a button for deleting the filter, if you want to close it.</i>', 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( 'Step 12: Specify the required parameters in the appeared filter fields.', 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( '<i>Note: If you want to perform a group operation with filters, then set the corresponding group operation in the "Logical operation" field and repeat steps 10-12."</i>', 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( '<i>Note: But, it is possible that instead of steps 9-12, you can simply change the previous filter and immediately proceed to step 13.</i>'
    , 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( 'Step 13: And execute one of the commands (click on the corresponding button) : "Merge", "Intersect", "Exclude", "Reverse Exception", "Exclusive OR"
    (For more information, see the table "Operations with the main list of users" in the "Additional information")', 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( '<i>Note: And if necessary, repeat steps 9-13.</i>', 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( 'Step 14: To run the command "Publish" («Update»).',  'giveaways-for-woocommerce');

$fr_txt_arr[] = __( 'Step 15: In the notification window that appears for the administrator, confirm or cancel the distribution of notifications to users.',  'giveaways-for-woocommerce');

$fr_txt_arr[] = '</br>';


$fr_txt_arr[] = __( '<u>Setting a task to add and update notifications</u>', 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( '<i>Note: In the instructions "Adding and updating notifications (Single-Operative filling of the main list of users) and "Adding and updating notifications (Multi- Operative filling of the main list of users) after <code>"
Step2: Check the box "Notification". "</code> need to add <code>" Step _: Check the box "CRON" and specify the date and time of the planned mailing. "</code> А <code>"
Step 15: In the notification window that appears for the administrator, confirm or cancel the distribution of notifications to users.
"</code> replaced by <code>" Step 15: In the notification window for the administrator, confirm or cancel the setting of the "CRON" task to send notifications to users .
"</code></i>', 'giveaways-for-woocommerce');

$fr_txt_arr[] = '</br>';



$fr_txt_arr[] = __( '<u>Adding columns to the main list of users</u>', 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( '<i>Note: This plugin helps not only to select users according to the specified conditions, but also to output additional information to the main user list (up to 7 columns) based on the available filters
(for more information on the output you can find in the special help, click on button with a question mark next to the list of filters).
And at the same time, if you created a column with additional information on the basis of a filter, then it is not necessary to apply it,
this column will be filled with relevant information for all users who are in the main list of users.</i>', 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( 'Step 1: Click the "Add Filter" button.', 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( 'Step 2: Select one of the filters in the list that appears (The list of available filters with descriptions,
see the table "Filter description" in the section "Additional information") for create a column with relevant additional information.'
    , 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( 'Step 3: Specify the required parameters in the appeared filter fields.', 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( 'Step 4: Specify the name of the column in the field "Column denomination".', 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( 'Step 5: Click on the "Add Column" button.', 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( '<i>Note: If you want to add more columns with additional information, repeat steps 1-5. In this way, you can add 5 columns and 2 more standard columns (email and role) by checking the appropriate checkboxes on the "Columns setup"</i>'
    , 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( 'Step 6: Click on the "Update Columns" button.', 'giveaways-for-woocommerce');

$fr_txt_arr[] = '</br>';


$fr_txt_arr[] = __( '<u>Removing columns from the main user list</u>', 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( 'Step 1: Go to the "Column Settings" tab.', 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( 'Step 2: Remove the appropriate checkboxes.', 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( 'Step 3: Go to the "user`s Filter" tab.', 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( 'Step 4: Click on the "Update Columns" button.', 'giveaways-for-woocommerce');

$fr_txt_arr[] = '</br>';


$fr_txt_arr[] = __( '<u>Delete notification (1 way)</u>', 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( 'Step 1: Open the corresponding coupon and uncheck "Notification".', 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( 'Step 2: To run the command "Publish" («Update»).',  'giveaways-for-woocommerce');

$fr_txt_arr[] = __( 'Step 3: In the notification window that appears for the administrator, confirm or cancel deletion of notifications to users.',  'giveaways-for-woocommerce');

$fr_txt_arr[] = '</br>';


$fr_txt_arr[] = __( '<u>Delete notification (2 way)</u>', 'giveaways-for-woocommerce');

$fr_txt_arr[] = __( 'Step 1: Delete matching coupon', 'giveaways-for-woocommerce');


 for ($i = 0; $i < count($fr_txt_arr); $i++)
  {
    $fr_txt_p = $fr_txt_arr[$i];

$fr_txt = <<<EOT
    <p class="frm_description">$fr_txt_p</p>
EOT;

    $fr_txt_gen = $fr_txt_gen . $fr_txt;
  }

    echo $head . $fr_txt_gen . '</br>';


//---------------------------------------------------------------------------------

$ai_head  = '<h2>' . __('Additional information', 'giveaways-for-woocommerce') . '</h2>';

$fr_dat_cap = __( 'Shortcode options "dcp_date"', 'giveaways-for-woocommerce');
$fr_dat_gen = <<<EOT
<table class="frm_tb_filter">
    <caption class="frm_cp_filter">$fr_dat_cap</caption>
    <tbody>
EOT;
        $tr = array();
        $clm1 = array();
        $clm2 = array();
        $clm3 = array();

        $tr[] = FALSE;
        $clm1[] = __( 'Day of the month', 'giveaways-for-woocommerce');
        $clm2[] = '';
        $clm3[] = '';

        $tr[] = TRUE;
        $clm1[] = 'd';
        $clm2[] = '01–31';
        $clm3[] = __( 'Number, with zero ahead', 'giveaways-for-woocommerce');

        $tr[] = TRUE;
        $clm1[] = 'j';
        $clm2[] = '1–31';
        $clm3[] = __( 'Number without zero ahead', 'giveaways-for-woocommerce');

        $tr[] = TRUE;
        $clm1[] = 'S';
        $clm2[] = 'st, nd or th in the 1st, 2nd or 15th.';
        $clm3[] = __( 'English ordinal suffix for the day of the month', 'giveaways-for-woocommerce');

        $tr[] = FALSE;
        $clm1[] = __( 'Day of the week', 'giveaways-for-woocommerce');
        $clm2[] = '';
        $clm3[] = '';

        $tr[] = TRUE;
        $clm1[] = 'l';
        $clm2[] = __( 'Sunday – Saturday', 'giveaways-for-woocommerce');
        $clm3[] = __( 'Full name (строчная "L")', 'giveaways-for-woocommerce');

        $tr[] = TRUE;
        $clm1[] = 'D';
        $clm2[] = __( 'Mon – Sun', 'giveaways-for-woocommerce');
        $clm3[] = __( 'Abbreviated name', 'giveaways-for-woocommerce');

        $tr[] = TRUE;
        $clm1[] = 'N';
        $clm2[] = __( '1 (monday) - 7 (sunday)', 'giveaways-for-woocommerce');
        $clm3[] = __( 'Numeric representation of the day of the week', 'giveaways-for-woocommerce');

        $tr[] = TRUE;
        $clm1[] = 'w';
        $clm2[] = __( '0 (sunday) - 6 (saturday)', 'giveaways-for-woocommerce');
        $clm3[] = __( 'Numeric representation of the day of the week', 'giveaways-for-woocommerce');

        $tr[] = FALSE;
        $clm1[] = __( 'Month', 'giveaways-for-woocommerce');
        $clm2[] = '';
        $clm3[] = '';

        $tr[] = TRUE;
        $clm1[] = 'm';
        $clm2[] = '01–12';
        $clm3[] = __( 'Number, with leading zeros', 'giveaways-for-woocommerce');

        $tr[] = TRUE;
        $clm1[] = 'n';
        $clm2[] = '1–12';
        $clm3[] = __( 'Number without leading zeros', 'giveaways-for-woocommerce');

        $tr[] = TRUE;
        $clm1[] = 'F';
        $clm2[] = __( 'January – December', 'giveaways-for-woocommerce');
        $clm3[] = __( 'Full name', 'giveaways-for-woocommerce');

        $tr[] = TRUE;
        $clm1[] = 'M';
        $clm2[] = __( 'Jan - Dec', 'giveaways-for-woocommerce');
        $clm3[] = __( 'Abbreviated name', 'giveaways-for-woocommerce');

        $tr[] = TRUE;
        $clm1[] = 't';
        $clm2[] = '28 - 31';
        $clm3[] = __( 'Number of days in the given month', 'giveaways-for-woocommerce');

        $tr[] = FALSE;
        $clm1[] = __( 'Year', 'giveaways-for-woocommerce');
        $clm2[] = '';
        $clm3[] = '';

        $tr[] = TRUE;
        $clm1[] = 'Y';
        $clm2[] = '1999, 2003';
        $clm3[] = __( 'Number, 4 digits', 'giveaways-for-woocommerce');

        $tr[] = TRUE;
        $clm1[] = 'y';
        $clm2[] = '99, 03';
        $clm3[] = __( 'Number, 2 digits', 'giveaways-for-woocommerce');

        $tr[] = TRUE;
        $clm1[] = 'z';
        $clm2[] = '0 - 365';
        $clm3[] = __( 'The day of the year (starting from 0)', 'giveaways-for-woocommerce');

        $tr[] = TRUE;
        $clm1[] = 'W';
        $clm2[] = __( '34 (34th week of the year)', 'giveaways-for-woocommerce');
        $clm3[] = __( 'The Week number in the year', 'giveaways-for-woocommerce');

        $tr[] = TRUE;
        $clm1[] = 'L';
        $clm2[] = __( '1 or 0', 'giveaways-for-woocommerce');
        $clm3[] = __( 'Whether it`s a leap year', 'giveaways-for-woocommerce');

        $tr[] = FALSE;
        $clm1[] = __( 'Time', 'giveaways-for-woocommerce');
        $clm2[] = '';
        $clm3[] = '';

        $tr[] = TRUE;
        $clm1[] = 'a';
        $clm2[] = 'am, pm';
        $clm3[] = __( 'Lowercase Ante meridiem and Post meridiem', 'giveaways-for-woocommerce');

        $tr[] = TRUE;
        $clm1[] = 'A';
        $clm2[] = 'AM, PM';
        $clm3[] = __( 'Uppercase Ante meridiem and Post meridiem', 'giveaways-for-woocommerce');

        $tr[] = TRUE;
        $clm1[] = 'h';
        $clm2[] = '01–12';
        $clm3[] = __( 'Watch (0-12), with leading zeros', 'giveaways-for-woocommerce');

        $tr[] = TRUE;
        $clm1[] = 'g';
        $clm2[] = '1–12';
        $clm3[] = __( 'Watch (0-12), without leading zeros', 'giveaways-for-woocommerce');

        $tr[] = TRUE;
        $clm1[] = 'H';
        $clm2[] = '00-23';
        $clm3[] = __( 'Watch (0-24), with leading zeros', 'giveaways-for-woocommerce');

        $tr[] = TRUE;
        $clm1[] = 'G';
        $clm2[] = '0-23';
        $clm3[] = __( 'Watch (0-24), without leading zeros', 'giveaways-for-woocommerce');

        $tr[] = TRUE;
        $clm1[] = 'i';
        $clm2[] = '00-59';
        $clm3[] = __( 'Minutes, with leading zeros', 'giveaways-for-woocommerce');

        $tr[] = TRUE;
        $clm1[] = 's';
        $clm2[] = '00-59';
        $clm3[] = __( 'Seconds, with leading zeros', 'giveaways-for-woocommerce');

        $tr[] = TRUE;
        $clm1[] = 'T';
        $clm2[] = 'EST, MDT ...';
        $clm3[] = __( 'Timezone abbreviation', 'giveaways-for-woocommerce');

        $tr[] = FALSE;
        $clm1[] = __( 'Full date and time', 'giveaways-for-woocommerce');
        $clm2[] = '';
        $clm3[] = '';

        $tr[] = TRUE;
        $clm1[] = 'c';
        $clm2[] = '2004-02-12T15:19:21+00:00';
        $clm3[] = __( 'Date in the format of ISO 8601 standard', 'giveaways-for-woocommerce');

        $tr[] = TRUE;
        $clm1[] = 'r';
        $clm2[] = 'Thu, 21 Dec 2000 16:01:07 +0200';
        $clm3[] = __( '» RFC 2822 formatted date', 'giveaways-for-woocommerce');

        $tr[] = TRUE;
        $clm1[] = 'U';
        $clm2[] = '1455880176';
        $clm3[] = __( 'Number, Unix timestamp - quantity of seconds since January 1, 1970', 'giveaways-for-woocommerce');

 for ($i = 0; $i < count($tr); $i++)
  {
    if($tr[$i]){
        $clm1_td = $clm1[$i];
        $clm2_td = $clm2[$i];
        $clm3_td = $clm3[$i];
$fr_dat = <<<EOT
  <tr class="frm_tr_filter">
    <td class="frm_name_filter">$clm1_td</td>
    <td class="frm_description_filter">$clm2_td</td>
    <td class="frm_description_filter">$clm3_td</td>
  </tr>
EOT;
    }else{
        $clm1_td = $clm1[$i];
$fr_dat = <<<EOT
  <tr class="frm_tr_filter">
    <th colspan="3" class="frm_th_filter">$clm1_td</th>
  </tr>
EOT;
    }
$fr_dat_gen = $fr_dat_gen . $fr_dat;
  }

$fr_dat_gen = $fr_dat_gen . '</tbody></table>';

//-------------------------------------------------------------------------------------

$fr_shc = __( 'Shortcode options "dcp_cuser"', 'giveaways-for-woocommerce');
$ai_user_gen = <<<EOT
<table class="frm_tb_filter">
  <caption class="frm_cp_filter">$fr_shc</caption>
    <tr><th class="frm_th_filter">WordPress</th></tr>
        <tr><th  class="frm_th_filter">&nbsp;&nbsp;&nbsp;&nbsp;users</th></tr>
            <tr><td class="frm_name_filter">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;ID</td></tr>
            <tr><td class="frm_name_filter">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;user_login</td></tr>
            <tr><td class="frm_name_filter">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;user_pass</td></tr>
            <tr><td class="frm_name_filter">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;user_nicename</td></tr>
            <tr><td class="frm_name_filter">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;user_email</td></tr>
            <tr><td class="frm_name_filter">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;user_url</td></tr>
            <tr><td class="frm_name_filter">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;user_registered</td></tr>
            <tr><td class="frm_name_filter">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;display_name</td></tr>
        <tr><th  class="frm_th_filter">&nbsp;&nbsp;&nbsp;&nbsp;user_meta</th></tr></tr>
            <tr><td class="frm_name_filter">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;first_name</td></tr>
            <tr><td class="frm_name_filter">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;last_name</td></tr>
            <tr><td class="frm_name_filter">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;nickname</td></tr>
            <tr><td class="frm_name_filter">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;description</td></tr>
            <tr><td class="frm_name_filter">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;wp_capabilities (array)</td></tr>
            <tr><td class="frm_name_filter">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;admin_color (Theme of your admin page. Default is fresh.)</td></tr>
            <tr><td class="frm_name_filter">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;closedpostboxes_page</td></tr>
            <tr><td class="frm_name_filter">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;primary_blog</td></tr>
            <tr><td class="frm_name_filter">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;rich_editing</td></tr>
            <tr><td class="frm_name_filter">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;source_domain</td></tr>
    <tr><th  class="frm_th_filter">Woocommerce</th></tr>
    	<tr><th  class="frm_th_filter">&nbsp;&nbsp;&nbsp;&nbsp;billing</th></tr>
    		<tr><td class="frm_name_filter">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;billing_first_name</td></tr>
    		<tr><td class="frm_name_filter">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;billing_last_name</td></tr>
    		<tr><td class="frm_name_filter">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;billing_company</td></tr>
    		<tr><td class="frm_name_filter">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;billing_address_1</td></tr>
    		<tr><td class="frm_name_filter">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;billing_address_2</td></tr>
    		<tr><td class="frm_name_filter">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;billing_city</td></tr>
    		<tr><td class="frm_name_filter">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;billing_postcode</td></tr>
    		<tr><td class="frm_name_filter">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;billing_country</td></tr>
    		<tr><td class="frm_name_filter">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;billing_state</td></tr>
    		<tr><td class="frm_name_filter">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;billing_phone</td></tr>
    		<tr><td class="frm_name_filter">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;billing_email</td></tr>
    	<tr><th  class="frm_th_filter">&nbsp;&nbsp;&nbsp;&nbsp;shipping</th></tr>
    		<tr><td class="frm_name_filter">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;copy_billing</td></tr>
    		<tr><td class="frm_name_filter">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;shipping_first_name</td></tr>
    		<tr><td class="frm_name_filter">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;shipping_last_name</td></tr>
    		<tr><td class="frm_name_filter">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;shipping_company</td></tr>
    		<tr><td class="frm_name_filter">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;shipping_address_1</td></tr>
    		<tr><td class="frm_name_filter">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;shipping_address_2</td></tr>
    		<tr><td class="frm_name_filter">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;shipping_city</td></tr>
    		<tr><td class="frm_name_filter">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;shipping_postcode</td></tr>
    		<tr><td class="frm_name_filter">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;shipping_country</td></tr>
    		<tr><td class="frm_name_filter">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;shipping_state</td></tr>
    </table>
EOT;

//-------------------------------------------------------------------------------------

$ai_filter_gen = '';

$ai_filter_capt = __('Description of filters', 'giveaways-for-woocommerce');
$ai_filter_nam = __('Denomination', 'giveaways-for-woocommerce');
$ai_filter_disc = __('Description ', 'giveaways-for-woocommerce');

$ai_filter_gen = <<<EOT
<table class="frm_tb_filter">
  <caption class="frm_cp_filter">$ai_filter_capt</caption>
  <tr>
    <th class="frm_th_filter">$ai_filter_nam</th>
    <th  class="frm_th_filter">$ai_filter_disc</th>
  </tr>
EOT;

    $aif_head = array();
    $aif_result = array();

    $aif_head[] = __('---According to users---', 'giveaways-for-woocommerce');
    $aif_result[] = '';

    $aif_head[] = __('By user role', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users with the specified role.', 'giveaways-for-woocommerce');

    $aif_head[] = __('By users role for the specified period', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users with this role who registered in the specified period.', 'giveaways-for-woocommerce');

    $aif_head[] = __('By users emails selected', 'giveaways-for-woocommerce');
    $aif_result[] =  __('All users from the specified emails list.', 'giveaways-for-woocommerce');

    $aif_head[] =  __('By role and user name', 'giveaways-for-woocommerce');
    $aif_result[] =  __('All users with this role and name containing the specified symbols that were registered in the specified period.', 'giveaways-for-woocommerce');

    $aif_head[] =  __('By role and login user ', 'giveaways-for-woocommerce');
    $aif_result[] =  __('All users with this role and login containing the specified symbols that were registered in the specified period.', 'giveaways-for-woocommerce');

    $aif_head[] =  __('By role and user url', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users with this role and url containing the specified symbols that were registered in the specified period.', 'giveaways-for-woocommerce');

    $aif_head[] =  __('By role and display name of the user', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users with this role and display name containing the specified symbols that were registered in the specified period.', 'giveaways-for-woocommerce');

    $aif_head[] =  __('By the role and name (woocommerce) of the user', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users with this role and name (woocommerce) containing the specified symbols that were registered in the specified period.', 'giveaways-for-woocommerce');

    $aif_head[] =  __('By the role and surname (woocommerce) of the user', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users with this role and surname (woocommerce) containing the specified symbols that were registered in the specified period.', 'giveaways-for-woocommerce');

    $aif_head[] =  __('By the role and company (woocommerce) of the user', 'giveaways-for-woocommerce');
    $aif_result[] = __('By the role and company (woocommerce) of the user', 'giveaways-for-woocommerce');

    $aif_head[] =  __('By the role and address-1 (woocommerce) of the user', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users with this role and address-1 (woocommerce) containing the specified symbols that were registered in the specified period.', 'giveaways-for-woocommerce');

    $aif_head[] =  __('By the role and address-2 (woocommerce) of the user', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users with this role and address-2 (woocommerce) containing the specified symbols that were registered in the specified period.', 'giveaways-for-woocommerce');

    $aif_head[] =  __('By role and city (woocommerce) of the user', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users with this role and the name of the city (woocommerce) containing the specified symbols that were registered in the specified period.', 'giveaways-for-woocommerce');

    $aif_head[] =  __('By role and post code (woocommerce) of the user ', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users with this role and a postal code (woocommerce) containing the specified symbols that were registered in the specified period.', 'giveaways-for-woocommerce');

    $aif_head[] =  __('By role and country (woocommerce) of the user', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users with this role and from the country (woocommerce) containing the specified symbols that were registered in the specified period.', 'giveaways-for-woocommerce');

    $aif_head[] =  __('By role and area of residence(woocommerce) of the user', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users with this role and state(woocommerce) containing the specified symbols that were registered in the specified period.', 'giveaways-for-woocommerce');

    $aif_head[] =  __('By the role and number of the user`s phone (woocommerce)', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users with this role and phone number (woocommerce) containing the specified symbols that were registered in the specified period.', 'giveaways-for-woocommerce');

    $aif_head[] =  __('By role and email (woocommerce) of the user', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users with this role and email (woocommerce) containing the specified symbols that were registered in the specified period.', 'giveaways-for-woocommerce');

    $aif_head[] =  __('------According to users(LIKE)-----', 'giveaways-for-woocommerce');
    $aif_result[] = '';

    $aif_head[] =  __('By role and user name(LIKE)', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users with this role and the name that corresponds to the specified template (LIKE) registered in this period.', 'giveaways-for-woocommerce');

    $aif_head[] =  __('By role and login user (LIKE)', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users with this role and the login that corresponds to the specified template (LIKE) registered in this period.', 'giveaways-for-woocommerce');

    $aif_head[] =  __('By role and email of the user(LIKE)', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users with this role and the email that corresponds to the specified template (LIKE) registered in this period.', 'giveaways-for-woocommerce');

    $aif_head[] =  __('By role and user url(LIKE)', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users with this role and url  that corresponds to the specified template (LIKE) registered in this period.', 'giveaways-for-woocommerce');

    $aif_head[] =  __('By role and display name of the user(LIKE)', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users with this role and display name  that corresponds to the specified template (LIKE) registered in this period.', 'giveaways-for-woocommerce');

    $aif_head[] =  __('By role and name (woocommerce) of the user (LIKE)', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users with this role and name (woocommerce) that corresponds to the specified template (LIKE) registered in this period.', 'giveaways-for-woocommerce');

    $aif_head[] =  __('By role and surname (woocommerce) of the user (LIKE)', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users with this role and surname (woocommerce) that corresponds to the specified template (LIKE) registered in this period.', 'giveaways-for-woocommerce');

    $aif_head[] =  __('By role and company (woocommerce) of the user (LIKE)', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users with this role and the company name (woocommerce) that corresponds to the specified template (LIKE) registered in this period.', 'giveaways-for-woocommerce');

    $aif_head[] =  __('By role and address-1 (woocommerce) of the user (LIKE)', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users with this role and address-1 (woocommerce) that corresponds to the specified template (LIKE) registered in this period.', 'giveaways-for-woocommerce');

    $aif_head[] =  __('By the role and address-2 (woocommerce) of the user(LIKE)', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users with this role and address-2 (woocommerce) that corresponds to the specified template (LIKE) registered in this period.', 'giveaways-for-woocommerce');

    $aif_head[] =  __('By role and city (woocommerce) of the user (LIKE)', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users with this role and city name (woocommerce) that corresponds to the specified template (LIKE) registered in this period.', 'giveaways-for-woocommerce');

    $aif_head[] =  __('By the role and postal code (woocommerce) user (LIKE)', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users with this role and Postal code(woocommerce) that corresponds to the specified template (LIKE) registered in this period.', 'giveaways-for-woocommerce');

    $aif_head[] =  __('By role and country (woocommerce) of the user (LIKE)', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users with this role and the name of the country (woocommerce) that corresponds to the specified template (LIKE) registered in this period.', 'giveaways-for-woocommerce');

    $aif_head[] =  __('By role and area of residence(woocommerce) of the user(LIKE)', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users with this role and name of the state (woocommerce) that corresponds to the specified template (LIKE) registered in this period.', 'giveaways-for-woocommerce');

    $aif_head[] =  __('By the role and number of the user`s phone (woocommerce)(LIKE)', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users with this role and phone number (woocommerce) that corresponds to the specified template (LIKE) registered in this period.', 'giveaways-for-woocommerce');

    $aif_head[] =  __('By role and email (woocommerce) of the user (LIKE)', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users with this role and email (woocommerce) that corresponds to the specified template (LIKE) registered in this period.', 'giveaways-for-woocommerce');

    $aif_head[] = __('---On selected categories---', 'giveaways-for-woocommerce');
    $aif_result[] = '';

    $aif_head[] =  __('The sum of orders on the selected categories is greater than or equal to the specified value ', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users whose sum for all orders from the selected categories for a given period of time is greater than or equal to the specified value.', 'giveaways-for-woocommerce');

    $aif_head[] =  __('The sum of orders on the selected categories is less than or equal to the specified value ', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users whose sum for all orders from the selected categories for a given period of time is less than or equal to the specified value.', 'giveaways-for-woocommerce');

    $aif_head[] =  __('The sum of orders on the selected categories is within the specified range of values', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users whose sum for all orders from the selected categories for a given period of time is in the specified range of values.', 'giveaways-for-woocommerce');

    $aif_head[] =  __('The quantity of goods on the selected categories is greater than or equal to the specified value ', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users whose quantity of goods for all orders from the selected categories for a given period of time is greater than or equal to the specified value.', 'giveaways-for-woocommerce');

    $aif_head[] =  __('The quantity of goods on the selected categories is less than or equal to the specified value ', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users whose quantity of goods for all orders from the selected categories for a given period of time is less than or equal to the specified value.', 'giveaways-for-woocommerce');

    $aif_head[] =  __('The quantity of goods in the selected categories is within the specified range of values', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users whose quantity of goods for all orders from the selected categories for a given period of time is in the specified range of values.', 'giveaways-for-woocommerce');

    $aif_head[] =  __('Positions of users at the selection on the increase in the quantity of goods', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users whose position in the sample on the increase the quantity of goods for all orders from the selected categories for a given period of time is in the specified range of values.', 'giveaways-for-woocommerce');

    $aif_head[] =  __('Positions of users at the sample (category) on the increase the sum for orders', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users whose position in the sample on the increase the sum of orders for all orders from the selected categories for a given period of time is in the specified range of values.', 'giveaways-for-woocommerce');

    $aif_head[] =  __('Positions of users at the sample (category) in descending of the quantity of goods', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users whose position in the sample in descending of the quantity of goods for all orders from the selected categories for a given period of time is in the specified range of values.', 'giveaways-for-woocommerce');

    $aif_head[] =  __('Positions of users at the sample (category) in descending the sum for orders', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users whose position in the sample in descending the sum of orders for all orders from the selected categories for a given period of time is in the specified range of values.', 'giveaways-for-woocommerce');

    $aif_head[] = __('---On selected goods---', 'giveaways-for-woocommerce');
    $aif_result[] = '';

    $aif_head[] =  __('The sum of orders for the selected goods is greater than or equal to the specified value ', 'giveaways-for-woocommerce');
    $aif_result[] =  __('All users whose sum for all orders from the selected goods for a given period of time is greater than or equal to the specified value.', 'giveaways-for-woocommerce');

    $aif_head[] =  __('The sum of orders for the selected goods is less than or equal to the specified value ', 'giveaways-for-woocommerce');
    $aif_result[] =  __('All users whose sum for all orders from the selected goods for a given period of time is less than or equal to the specified value.', 'giveaways-for-woocommerce');

    $aif_head[] =  __('The sum of orders for the selected goods is in the specified range of values', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users whose sum for all orders from the selected goods for a given period of time is in the specified range of values.', 'giveaways-for-woocommerce');

    $aif_head[] =   __('The quantity of goods on the selected denomination is greater or equal to the specified value ', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users whose quantity of goods for all orders from the selected denominations for a given period of time is greater than or equal to the specified value.', 'giveaways-for-woocommerce');

    $aif_head[] =  __('The quantity of goods on the selected denomination is less than or equal to the specified value ', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users whose quantity of goods for all orders from the selected denominations for a given period of time is less than or equal to the specified value.', 'giveaways-for-woocommerce');

    $aif_head[] =  __('The quantity of goods for the selected denominations is in the specified range of values', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users whose quantity of goods for all orders from the selected denominations for a given period of time is in the specified range of values.', 'giveaways-for-woocommerce');

    $aif_head[] = __('Positions of users in the sample (goods) by increasing the quantity of goods', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users whose position in the selection for increasing the quantity of goods for all orders from the selected denominations for a given period of time is in the specified range of values.', 'giveaways-for-woocommerce');

    $aif_head[] =   __('Positions of users in the sample (goods) on the increase the sum for orders', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users whose position in the sample on the increase the sum of orders for all orders from the selected denominations for a given period of time is in the specified range of values.', 'giveaways-for-woocommerce');

    $aif_head[] =  __('Positions of users in the sample (goods) in descending of the quantity of goods', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users whose position in the sample in descending of the quantity of goods for all orders from the selected denominations for a given period of time is in the specified range of values.', 'giveaways-for-woocommerce');

    $aif_head[] = __('Positions of users in the sample (goods) in descending the sum for orders', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users whose position in the sample in descending the sum of orders for all orders from the selected denominations for a given period of time is in the specified range of values.', 'giveaways-for-woocommerce');

    $aif_head[] = __('---For all orders---', 'giveaways-for-woocommerce');
    $aif_result[] = '';

    $aif_head[] =  __('The sum of all orders for goods is greater than or equal to the specified value ', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users whose sum for all orders for a given period of time is greater than or equal to the specified value.', 'giveaways-for-woocommerce');

    $aif_head[] =  __('The sum of all orders for goods is less than or equal to the specified value ', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users whose sum for all orders for a given period of time is less than or equal to the specified value.', 'giveaways-for-woocommerce');

    $aif_head[] =  __('The sum of all orders is in the specified range of values', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users whose sum for all orders for a given period of time is in the specified range of values.', 'giveaways-for-woocommerce');

    $aif_head[] =  __('Positions of users at the selection on the increase the sum for all orders', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users whose position in the sample on the increase the sum of orders for all orders for a given period of time is in the specified range of values.', 'giveaways-for-woocommerce');

    $aif_head[] =  __('Positions of users when selecting in descending the sum of all orders', 'giveaways-for-woocommerce');
    $aif_result[] =  __('All users whose position in the sample on descending the sum of orders for all orders for a given period of time is in the specified range of values.', 'giveaways-for-woocommerce');

    $aif_head[] = __('---By the selected coupons---', 'giveaways-for-woocommerce');
    $aif_result[] = '';

    $aif_head[] =  __('Use of this coupon for selected categories', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users who used this coupon in the selected categories for a given period of time.', 'giveaways-for-woocommerce');

    $aif_head[] =  __('Positions of users in the sample (coupon) on the increase in the sum of orders', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users whose position in the sample on the increase in the sum of orders for all orders with a discount for this coupon for a given period of time is in the specified range of values.', 'giveaways-for-woocommerce');

    $aif_head[] =  __('Positions of users on the sample (coupon) on descending the sum of orders ', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users whose position in the sample on the increase in the sum of orders for all orders with a discount for this coupon for a given period of time is in the specified range of values.', 'giveaways-for-woocommerce');

    $aif_head[] =  __('Positions of users in the sample (coupon) ascending the date (first) orders', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users whose position in the selection by increasing the date (first) orders for all orders with a discount for this coupon for a given period of time is in the specified range of values.', 'giveaways-for-woocommerce');

    $aif_head[] = __('Positions of users in the sample (coupon) in descending the date (first) orders', 'giveaways-for-woocommerce');
    $aif_result[] = __('All users whose position at the selection on descending the date (first) orders for all orders with a discount for this coupon for a given period of time is in the specified range of values.', 'giveaways-for-woocommerce');

 for ($i = 0; $i < count($aif_head); $i++)
  {
   $aif_head_td = $aif_head[$i];
   $aif_result_td = $aif_result[$i];

$aif_filter = <<<EOT
  <tr class="frm_tr_filter">
    <td class="frm_name_filter">$aif_head_td</td>
    <td class="frm_description_filter">$aif_result_td</td>
  </tr>
EOT;

$ai_filter_gen = $ai_filter_gen . $aif_filter;
  }

    $ai_filter_gen = $ai_filter_gen . '</table>';



 $ai_operat_gen = '';

$ai_operat_capt = __('Operations with the main list of users', 'giveaways-for-woocommerce');
$ai_operat_nam = __('Denomination', 'giveaways-for-woocommerce');
$ai_operat_disc = __('Description ', 'giveaways-for-woocommerce');

$ai_operat_gen = <<<EOT
<table class="frm_tb_filter">
  <caption class="frm_cp_filter">$ai_operat_capt</caption>
  <tr>
    <th class="frm_th_filter">$ai_operat_nam</th>
    <th  class="frm_th_filter">$ai_operat_disc</th>
  </tr>
EOT;

    $aiop_head = array();
    $aiop_result = array();

    $aiop_head[] = __('Merger', 'giveaways-for-woocommerce');
    $aiop_result[] = __('In the main list placed all users who already exist in the main list and all users that were selected by the current filter.  In cases of coincidence of users, it is added only once (this operation corresponds to the logical operation "OR").', 'giveaways-for-woocommerce');;

    $aiop_head[] = __('Intersection', 'giveaways-for-woocommerce');
    $aiop_result[] = __('The main list placed only by those users who are in both the lists "Main list of users" and "List selected by the current filter" (this operation corresponds to the logical operation "AND")', 'giveaways-for-woocommerce');

    $aiop_head[] = __('Exclude', 'giveaways-for-woocommerce');
    $aiop_result[] = __('From the main list of users, all users who are in the list selected by the current filters will be removed, the result will be placed in the main user list.', 'giveaways-for-woocommerce');

    $aiop_head[] = __('Reverse exception', 'giveaways-for-woocommerce');
    $aiop_result[] =  __('From the list selected by the current filter, all users that are in the main user list will be excluded and the result will be placed in the main user list.', 'giveaways-for-woocommerce');

    $aiop_head[] = __('Exclusive OR', 'giveaways-for-woocommerce');
    $aiop_result[] =  __('The main list placed all users who already exist in the main list and all users that were selected by the current filter. In case of coincidence of users, they will be excluded from the list (this operation corresponds to the logical operation "XOR")).', 'giveaways-for-woocommerce');


     for ($i = 0; $i < count($aiop_head); $i++)
  {
   $aiop_head_td = $aiop_head[$i];
   $aiop_result_td = $aiop_result[$i];

$aiop_operat = <<<EOT
  <tr class="frm_tr_filter">
    <td class="frm_name_filter">$aiop_head_td</td>
    <td class="frm_description_filter">$aiop_result_td</td>
  </tr>
EOT;

$ai_operat_gen = $ai_operat_gen . $aiop_operat;
  }

    $ai_operat_gen = $ai_operat_gen . '</table>';



    echo $ai_head . '</br>' . $fr_dat_gen . '</br>' . '</br>' . $ai_user_gen .'</br>' . '</br>' . $ai_filter_gen .'</br>' . '</br>' .  $ai_operat_gen;
}



    /**
     * Creating a plugin settings page.
     */
    function admin_panel_dispatch_coupons($settings) {
    	$settings[] = include( DISPATCH_OF_COUPONS::dcp_path() . '/includes/admin/class-dcp-admin-settings.php' );
    	return $settings;
    }

  /**
   * Adding your field type (label) to admin settings.
   */
   	public static function get_field_description( $value ) {
		$description  = '';
		$tooltip_html = '';

		if ( true === $value['desc_tip'] ) {
			$tooltip_html = $value['desc'];
		} elseif ( ! empty( $value['desc_tip'] ) ) {
			$description  = $value['desc'];
			$tooltip_html = $value['desc_tip'];
		} elseif ( ! empty( $value['desc'] ) ) {
			$description  = $value['desc'];
		}

		if ( $description && in_array( $value['type'], array( 'textarea', 'radio' ) ) ) {
			$description = '<p style="margin-top:0">' . wp_kses_post( $description ) . '</p>';
		} elseif ( $description && in_array( $value['type'], array( 'checkbox' ) ) ) {
			$description = wp_kses_post( $description );
		} elseif ( $description ) {
			$description = '<span class="description">' . wp_kses_post( $description ) . '</span>';
		}

		if ( $tooltip_html && in_array( $value['type'], array( 'checkbox' ) ) ) {
			$tooltip_html = '<p class="description">' . $tooltip_html . '</p>';
		} elseif ( $tooltip_html ) {
			$tooltip_html = wc_help_tip( $tooltip_html );
		}

		return array(
			'description'  => $description,
			'tooltip_html' => $tooltip_html,
		);
	}


   /**
   * Creating a special label element.
   */
  public static function admin_options_label_dcp($value) {
    $option_value = WC_Admin_Settings::get_option($value['id'], $value['default']);

    // Description handling
		$field_description = self::get_field_description( $value );
		extract( $field_description );

    ?><tr valign="top">
        		<th scope="row" class="titledesc">
        			<label for="<?php echo esc_attr($value['id']); ?>"><?php echo esc_html($value['title']); ?></label>
        			<?php echo $tooltip_html; ?>
        		</th>
        		<td class="forminp forminp-<?php echo sanitize_title($value['type']) ?>">
        			<span id="<?php echo esc_attr($value['id']); ?>" class="<?php echo esc_attr($value['class']); ?>"><?php echo esc_html($value['value']); ?></span>
        			<?php echo $description; ?>
        		</td>
        	</tr><?php
  }

    /**
     * Creating a special button element.
     */
  public static function admin_options_button_dcp($value) {
       $option_value = WC_Admin_Settings::get_option($value['id'], $value['default']);

       // Description handling
			$field_description = self::get_field_description( $value );
			extract( $field_description );

        ?><tr valign="top">
            <th scope="row" class="titledesc">
    			<label for="<?php echo esc_attr($value['id']); ?>"><?php echo esc_html($value['title']); ?></label>
    			<?php echo $tooltip_html; ?>
    		</th>
            <td class="forminp forminp-<?php echo sanitize_title($value['type']) ?>">
                <button type="button" id="<?php echo esc_attr($value['id']); ?>" class="<?php echo esc_attr($value['class']); ?>"><?php echo esc_html($value['value']); ?></button>
                <?php echo $description; ?>
            </td>
    	</tr><?php
  }
}
DCP_ADMIN_PANEL::init();
