<?php
/**
 * Add columns to the list of coupons.
 *
 * @package  Giveaways for woocommerce/Classes
 * @author   Sindyakin Sergei
 * @version 1.0.0
 */

if (!defined('ABSPATH')) {
  exit;
}

class DCP_LIST_COUPONS {
   /**
	 * Hook in ajax handlers.
	 */
      public static function init () {
        add_filter('manage_shop_coupon_posts_columns',  array(__CLASS__, 'custom_shop_order_column'), 11);
        add_action('manage_shop_coupon_posts_custom_column',  array(__CLASS__, 'custom_orders_list_column_content'), 10, 2);
      }

    /**
     * Adding column titles (Here 1 column).
     */
    function custom_shop_order_column($columns) {
    	//add columns
    	if(WC_Admin_Settings::get_option('dcp_columns_notices_sse')=='yes'){
    	    $columns['notices_column'] = __('Notification', 'dispatch-of-coupons');
    	};

    	if(WC_Admin_Settings::get_option('dcp_columns_cron_sse')=='yes'){
    	    $columns['notices_cron'] = __('CRON', 'dispatch-of-coupons');
    	};

    	if(WC_Admin_Settings::get_option('dcp_columns_status_sse')=='yes'){
    	    $columns['notices_status'] = __('Status', 'dispatch-of-coupons');
    	};

    	return $columns;
    }

    /**
     *  Аdding the data for each orders by column (example).
     */
    function custom_orders_list_column_content($column) {
    	global $post;

    	switch ($column) {
    		case 'notices_column' :
    			$myVarOne = esc_html(get_post_meta($post->ID, 'dcp_notices_coupon_sse', true));
    			echo $myVarOne;
    			break;
    		case 'notices_cron' :
    			$myVarOne = esc_html(get_post_meta($post->ID, 'dcp_notices_coupon_cron_sse', true));
    			echo $myVarOne;
    			break;
    		case 'notices_status' :
    			$myVarOne = esc_html(get_post_meta($post->ID, 'dcp_notices_status_sse', true));
    			echo $myVarOne;
    			break;
    	}
    }

}
DCP_LIST_COUPONS::init();