<?php
/**
 * Deleting coupons processing
 *
 * @package  Giveaways for woocommerce/Classes
 * @author   Sindyakin Sergei
 * @version 1.0.0
 */

if (!defined('ABSPATH')) {
  exit;
}

class DCP_HOOK {
    /**
	 * Hook in ajax handlers.
	 */
  public static function init () {
     add_action( 'before_delete_post', array(__CLASS__, 'del_coupon'),10);
     add_action( 'post_updated', array(__CLASS__, 'basket_coupon'), 10, 3 );
  }

    /**
	 * Deleting a coupon.
	 */
  public static function del_coupon( $coupon_id ) {
      $post = get_post( $coupon_id );

      // если нет, выходим.
      if( ! $post || $post->post_type !== 'shop_coupon' )
        return;

        $coupon_sse = new DCP_CP_NTC($coupon_id);

       	$getNotices = $coupon_sse->get_notices_coupon();
       	$getCron = $coupon_sse->get_notices_coupon_cron();

       	self::del_coupon_notices( $coupon_id, $getNotices, $getCron );

    return true;
  }

    /**
	 * Putting the coupon in the basket.
	 */
  public static function basket_coupon( $coupon_id, $post_after, $post_before ) {
      $post = get_post( $coupon_id );

     if($post_after->post_status == 'trash' and $post_after->post_type=='shop_coupon'){
     	unset($_SESSION['dcp_cp_ntc_old_sse_'.strval($coupon_id)]);

        $coupon_sse = new DCP_CP_NTC($coupon_id);

       switch ( $coupon_sse->get_notices_status_id() ) {
		case 0:
		case 2:
			$full_cleaning = false;
			$cleaning = false;
			break;
		case 1:
			$full_cleaning = false;
			$cleaning = true;
			break;
		case 3:
		case 4:
		case 5:
		case 6:
		case 7:
		case 100:
			$full_cleaning = true;
			$cleaning = false;
			break;
		default:
			$full_cleaning = true;
			$cleaning = false;
		}


	if($full_cleaning = false && $cleaning = false){
		$getNotices = false;
       		$getCron = false;
	}elseif($full_cleaning = false && $cleaning = true){
		$getNotices = $coupon_sse->get_notices_coupon();
       		$getCron = $coupon_sse->get_notices_coupon() && $coupon_sse->get_notices_coupon_cron();
	}else{
		$getNotices = true;
       		$getCron = true;
	}

       	self::del_coupon_notices( $coupon_id, $getNotices, $getCron );

	$post_notices_coupon = false;
	$post_notices_coupon_cron = false;
	$post_notices_status = __( 'There is no notifications', 'giveaways-for-woocommerce' );
	$post_notices_status_id = 0;

	$coupon_sse->set_props(array(
		'notices_coupon' 		=> $post_notices_coupon,
		'notices_coupon_cron' 		=> $post_notices_coupon_cron ,
		'notices_status' 		=> $post_notices_status,
		'notices_status_id' 		=> $post_notices_status_id ,
	));

	$coupon_sse->save();
    return true;
    }
   return false;
  }

    /**
	 * Delete coupon notifications.
	 */
  public static function del_coupon_notices( $coupon_id, $getNotices, $getCron ){
     if ($getNotices) {
  	$usersID = get_users( array( 'fields' => array('ID') ) );
      	$arrUsersID = wp_list_pluck($usersID, 'ID');

    	foreach ($arrUsersID as $userID) {
        	$user_id_coupon = esc_textarea(get_user_meta($userID, 'notices_new_coupon_id', true));
        	$pos = strripos($user_id_coupon, strval($coupon_id));

        	if ($pos !== false) {
          		$user_id_coupon = self::notices_del_user($coupon_id, $user_id_coupon);
          		update_user_meta($userID, 'notices_new_coupon_id', $user_id_coupon);
          		update_user_meta($userID, 'dcp_ntc_new_operat_name_sse', "del_coupon");
        		update_user_meta($userID, 'dcp_ntc_new_operat_time_sse', time());
        	}
    	}
    }

    if ($getCron) {
    	 $time_next_scheduled = wp_next_scheduled(
		'dcp_cp_ntc_dispatch_sse',
		array( $coupon_id )
		);

    	if ($time_next_scheduled > 0) {
        	wp_clear_scheduled_hook(
			'dcp_cp_ntc_dispatch_sse',
			array( $coupon_id )
			);
    	}
    }
	return;
  }

    /**
	 * Ancillary function for deleting coupon notifications.
	 */
  public static function notices_del_user($del_id, $user_id_coupon) {
    if ($user_id_coupon !== "") {
      $pos = strripos($user_id_coupon, ',');
      if ($pos) {
        $user_id_coupon = str_replace("," . $del_id . ",", ",", "," . $user_id_coupon . ",");
        $user_id_coupon = substr($user_id_coupon, 1, -1);
      } else {
        $user_id_coupon = str_replace($del_id, "", $user_id_coupon);
      }
    }
    return $user_id_coupon;
  }

}

DCP_HOOK::init();