<?php
/**
 * Save metadata in the coupon.
 *
 * @package  Giveaways for woocommerce/Classes
 * @author   Sindyakin Sergei
 * @version 1.0.0
 */

if (!defined('ABSPATH')) {
  exit;
}

class DCP_CP_NTC_SAVE {
    /**
     * Hook in ajax handlers.
     */
    public static function init () {
        add_action('woocommerce_coupon_options_save', array(__CLASS__, 'custom_coupon_options_save'), 10, 2);
    }

     /**
      * Coupon Coupon Processing.
      */
    public static function custom_coupon_options_save($post_id, $coupon) {

    	$coupon_sse = new DCP_CP_NTC($post_id);
    	$post_notices_coupon = isset($_POST['dcp_notices_coupon_sse']);
    	$post_notices_coupon_cron = isset($_POST['dcp_notices_coupon_cron_sse']);
    	$post_date_dispatch_notices = wc_clean($_POST['dcp_date_dispatch_notices_sse']);
    	$post_date_dispatch_notices_u = wc_clean($_POST['dcp_date_dispatch_notices_u_sse']);
    	$post_editor_notices = wp_kses_post($_POST['dcp_editor_notices_sse']);
    	$post_list_emails_n = isset($_POST['dcp_list_emails_n_sse']) ? wc_clean($_POST['dcp_list_emails_n_sse']): '';
    	$post_notices_status = isset($_POST['dcp_notices_status_sse']) ? wc_clean($_POST['dcp_notices_status_sse']): '';
    	$post_notices_status_id = isset($_POST['dcp_notices_status_id_sse']) ? wc_clean($_POST['dcp_notices_status_id_sse']): 0;
    	$post_notices_full_cleaning = isset($_POST['dcp_notices_full_cleaning_sse']);

    	$current_user = wp_get_current_user();
    	$post_save_user_id =  $current_user->ID;

    	if($post_notices_full_cleaning ){
    		if( $post_notices_status_id == 0 || $post_notices_status_id == 2 ){
    			$post_notices_status_id = 7;
    		}else{
    			$post_notices_status_id = 6;
    		}
    	}

    	/*
    		0 - empty
    		1 - confirmed
    		2 - Not confirmed new
    		3 - Not confirmed update
    		4 - Not confirmed clean
    		5 - Not confirmed, complete cleaning and refresh
    		6 - Unverified, complete cleaning and update
    		7 - Not confirmed, complete cleaning and add
    	*/

    	if($post_notices_coupon){
    		switch ( $post_notices_status_id ) {
    			case 0:
    			case 2:
    				$post_notices_status = __( 'Confirm new notification', 'giveaways-for-woocommerce');
    				$post_notices_status_id = 2;
    				break;
    			case 1:
    				$post_notices_status = __( 'Confirm notification change', 'giveaways-for-woocommerce');
    				$post_notices_status_id = 3;
    				break;
    			case 7:
    				$post_notices_status = __( 'Confirm new notification with full cleaning', 'giveaways-for-woocommerce');
    				$post_notices_status_id = 7;
    				break;
    			case 3:
    			case 4:
    			case 5:
    			case 6:
    			case 100:
    				$post_notices_status = __( 'Confirm change of notification with full clearing', 'giveaways-for-woocommerce');
    				$post_notices_status_id = 5;
    				break;
    			default:
    				$post_notices_status = __( 'Error', 'giveaways-for-woocommerce');
    				$post_notices_status_id = 100;
    			}
    	}else{
    		switch ( $post_notices_status_id ) {
    			case 0:
    			case 2:
    				$post_notices_status = __( 'There is no notification', 'giveaways-for-woocommerce');
    				$post_notices_status_id = 0;
    				break;
    			case 1:
    				$post_notices_status = __( 'Confirm clearing notifications', 'giveaways-for-woocommerce');
    				$post_notices_status_id = 4;
    				break;
    			case 3:
    			case 4:
    			case 5:
    			case 6:
    			case 7:
    			case 100:
    				$post_notices_status = __( 'Confirm full notification cleanup', 'giveaways-for-woocommerce');
    				$post_notices_status_id = 6;
    				break;
    			default:
    				$post_notices_status = __( 'Error', 'giveaways-for-woocommerce');
    				$post_notices_status_id = 100;
    			}
    	}

    	$coupon_sse->set_props(array(
    		'notices_coupon' 		=> $post_notices_coupon,
    		'notices_coupon_cron' 		=> $post_notices_coupon_cron ,
    		'date_dispatch_notices' 	=> $post_date_dispatch_notices ,
    		'date_dispatch_notices_u' 	=> $post_date_dispatch_notices_u,
    		'editor_notices' 		=> $post_editor_notices,
    		'list_emails_n' 		=> $post_list_emails_n,
    		'notices_status' 		=> $post_notices_status,
    		'notices_status_id' 		=> $post_notices_status_id ,
    		'save_user_id' 			=> $post_save_user_id,
    		'notices_full_cleaning' 	=> $post_notices_full_cleaning,
    	));

    	$coupon_sse->save();
    	$coupon_sse->confirm_sending_notices($post_id, $post_notices_coupon);
    }
}
DCP_CP_NTC_SAVE::init();