<?php
/**
 * Work with session variables.
 *
 * @package  Giveaways for woocommerce/Classes
 * @author   Sindyakin Sergei
 * @version 1.0.0
 */

if (!defined('ABSPATH')) {
  exit;
}

class DCP_CP_SESSION_SAVE {

    /**
     * Hook in ajax handlers.
     */
    public static function init () {
        add_action('woocommerce_coupon_options_save', array(__CLASS__, 'custom_coupon_options_save'), 10, 2);
        add_action('dcp_cp_ntc_loaded_sse', array(__CLASS__, 'dcp_cp_ntc_safekeeping_old'));
    }

    /**
     * Coupon Coupon Processing.
     */
    public static function custom_coupon_options_save($post_id, $coupon) {
    	$_SESSION['sse_coupon_id_' . $post_id] = $post_id;
    }

    /**
     * Preservation of pre-configured coupon distribution settings.
     */
    public static function dcp_cp_ntc_safekeeping_old($coupon_sse) {
    	$coupon_id = $coupon_sse->get_id();
    	if (isset($_SESSION['dcp_cp_ntc_old_sse_'.strval($coupon_id)]) === FALSE) {
    		$_SESSION['dcp_cp_ntc_old_sse_'.strval($coupon_id)] = (bool) $coupon_sse->get_notices_coupon();
    		$_SESSION['dcp_cp_ntc_cron_old_sse_'.strval($coupon_id)] = (bool) $coupon_sse->get_notices_coupon_cron();
    	}
    }

    /**
     * Clear the delete notification counter.
     */
    public static function ntc_clear_counter_del() {
    	$_SESSION['dcp_ntc_clear_counter_del_sse'] = 0;
    }

    /**
     * Increase the notification deletion counter.
     */
    public static function ntc_clear_counter_add($i=1) {
    	$_SESSION['dcp_ntc_clear_counter_del_sse'] = $_SESSION['dcp_ntc_clear_counter_del_sse'] + $i;
    }

    /**
     * Increase the notification deletion counter.
     */
    public static function ntc_start_time() {
    	$_SESSION['dcp_ntc_start_time_sse'] = time();
    }
}
DCP_CP_SESSION_SAVE::init();