<?php
/**
 * Add / remove notification to user.
 *
 * @package  Giveaways for woocommerce/Classes
 * @author   Sindyakin Sergei
 * @version 1.0.0
 */

if (!defined('ABSPATH')) {
  exit;
}

class DCP_HOOK_NTC {
    /**
	 * Hook in ajax handlers.
	 */
  public static function init () {
     add_action('dcp_cp_ntc_dispatch_sse', array(__CLASS__, 'new_coupon_notices'),10);
  }

    /**
     *  Add a notification.
     *
     *  @param  int $coupon_id
     *  @return bool
     */
 public static function new_coupon_notices($coupon_id) {
	$coupon_sse = new DCP_CP_NTC($coupon_id);
    	$coupon_emails = DCP_FUNCTIONS::coupon_emails_all($coupon_sse->get_list_emails_n());

    foreach ($coupon_emails as $email) {
      if ($user = get_user_by('email', $email)) {
        $user_id_coupon = esc_textarea(get_user_meta($user->ID, 'notices_new_coupon_id', true));
        if ($user_id_coupon !== "") {
          $user_id_coupon = self::notices_del_user($coupon_id, $user_id_coupon);
          $user_id_coupon = $coupon_id . ',' . $user_id_coupon;
        } else {
          $user_id_coupon = $coupon_id;
        }
        update_user_meta($user->ID, 'notices_new_coupon_id', $user_id_coupon);
        update_user_meta($user->ID, 'dcp_ntc_new_operat_name_sse', "add_coupon");
        update_user_meta($user->ID, 'dcp_ntc_new_operat_time_sse', time());
      }
    }
    return true;
  }

    /**
     * Delete the notification.
     *
     *  @param  int $del_id
     *  @param  int $user_id_coupon
     *  @return int
     */
  public static function notices_del_user($del_id, $user_id_coupon) {
    if ($user_id_coupon !== "") {
      $pos = strripos($user_id_coupon, ',');
      if ($pos) {
        $user_id_coupon = str_replace("," . $del_id . ",", ",", "," . $user_id_coupon . ",");
        $user_id_coupon = substr($user_id_coupon, 1, -1);
      } else {
        $user_id_coupon = str_replace($del_id, "", $user_id_coupon);
      }
    }
    return $user_id_coupon;
  }
}
DCP_HOOK_NTC::init();