<?php
/**
 * Formation of notifications to the user.
 *
 * @package  Giveaways for woocommerce/Classes
 * @author   Sindyakin Sergei
 * @version 1.0.0
 */

if (!defined('ABSPATH')) {
  exit;
}

class DCP_HTML_CODE_NOTIF {

    /**
     *  Formation of the notification.
     *
     *  @param  bool $next_ajax
     *  @return string
     */
	public static function account_new_coupons($next_ajax = TRUE) {
			$current_user = wp_get_current_user();
			$user_id = $current_user->ID;

			$user_id_coupon = esc_textarea(get_user_meta($user_id, 'notices_new_coupon_id', true));
			$user_id_coupon_arr = explode(",", $user_id_coupon);

			$cnt = count($user_id_coupon_arr);
      if (!empty($user_id_coupon)) {
        $notices_options['notif_navig'] = (int) WC_Admin_Settings::get_option('sse_notif_navig');
        if ($next_ajax) {
          $start_point = $_POST['end_point'] + 1-$_SESSION['dcp_ntc_clear_counter_del_sse'];
        } else {
          $start_point = 1;
        }
        DCP_CP_SESSION_SAVE::ntc_clear_counter_del();

        if ($notices_options['notif_navig'] !== 0 && $cnt - $start_point - 1 > $notices_options['notif_navig']) {
          $end_point   = $start_point + (int) $notices_options['notif_navig'] - 1;
          $button_next = TRUE;
        } else {
          $end_point   = $cnt;
          $button_next = FALSE;
        }

        //Get notification settings
        $notices_options              = array();
        $notices_options['rules_css'] = WC_Admin_Settings::get_option('sse_n_rules_css');

        if ($notices_options['rules_css'] == "yes") {
          $sse_html = self::html_notices_rules_yes($user_id_coupon_arr, $start_point, $end_point);
        } else {
          $sse_html = self::html_notices_rules_no($user_id_coupon_arr, $start_point, $end_point);
        }

        if ($button_next) {
          $sse_html = $sse_html . self::html_button_next($end_point);
        }

        return apply_filters( 'dcp_notices_html_sse', $sse_html, $user_id_coupon_arr, $start_point, $end_point, $button_next );
      } else {
        echo __('No information about new coupons', 'giveaways-for-woocommerce');
      }
		}

    /**
     *  Formation of the notification on CSS.
     *
     *  @param  array $user_id_coupon_arr
     *  @param  int $start_point
     *  @param  int $end_point
     *  @return string
     */
		private static function html_notices_rules_yes($user_id_coupon_arr, $start_point, $end_point) {
			$html_notices='';
			$notices_options['code_css'] = WC_Admin_Settings::get_option('sse_n_code_css');
			for ($i = $start_point; $i <= $end_point; $i++) {
			   if ( 'shop_coupon' === get_post_type($user_id_coupon_arr[$i - 1])) {
			   	$_SESSION['dcp_current_id_coupon_user_sse'] = $user_id_coupon_arr[$i - 1];
				$coupon_sse = new DCP_CP_NTC($user_id_coupon_arr[$i - 1]);
				$coupon_sse_notices = $coupon_sse->get_editor_notices();

				$html_notices =$html_notices
						. self::html_headline($user_id_coupon_arr[$i - 1])
						. '<div '
						. 'class="sse_notices_coupon_'. (int) $user_id_coupon_arr[$i - 1] .'" '
						. 'style="' . $notices_options['code_css']
						. '">'
						. do_shortcode(wpautop(wptexturize($coupon_sse_notices)))
						. self::html_button_del($user_id_coupon_arr[$i - 1])
						.'</div>';
				$_SESSION['dcp_current_id_coupon_user_sse'] = 0;
				}
			}
			return $html_notices;
		}

    /**
     *  The formation notification parametram.
     *
     *  @param  array $user_id_coupon_arr
     *  @param  int $start_point
     *  @param  int $end_point
     *  @return string
     */
		private static function html_notices_rules_no($user_id_coupon_arr, $start_point, $end_point) {
				$html_notices='';
				$notices_options['sse_n_back_col'] = WC_Admin_Settings::get_option('sse_n_back_col');
				$notices_options['sse_n_bord_top_col'] = WC_Admin_Settings::get_option('sse_n_bord_top_col');
				$notices_options['sse_n_marg_bottom'] = WC_Admin_Settings::get_option('sse_n_marg_bottom');
				$notices_options['sse_n_pad_left'] = WC_Admin_Settings::get_option('sse_n_pad_left');
				for ($i = $start_point; $i <= $end_point; $i++) {
				   if ( 'shop_coupon' === get_post_type($user_id_coupon_arr[$i - 1])) {
				   	$_SESSION['dcp_current_id_coupon_user_sse'] = $user_id_coupon_arr[$i - 1];
					$coupon_sse = new DCP_CP_NTC($user_id_coupon_arr[$i - 1]);
					$coupon_sse_notices = $coupon_sse->get_editor_notices();

					$html_notices =$html_notices
							. self::html_headline($user_id_coupon_arr[$i - 1])
							. '<div '
							. 'class="sse_notices_coupon_'. (int) $user_id_coupon_arr[$i - 1] .'" '
							. 'style="background-color: ' . $notices_options['sse_n_back_col'] .'; '
							. 'border-top-style: solid; '
							. 'border-top-color: ' . $notices_options['sse_n_bord_top_col'] .'; '
							. 'margin-bottom: ' . $notices_options['sse_n_marg_bottom'] .'px; '
							. 'padding: 10px 10px 10px ' . $notices_options['sse_n_pad_left'] .'px;'
							. '">'
							. do_shortcode(wpautop(wptexturize($coupon_sse_notices)))
							. self::html_button_del($user_id_coupon_arr[$i - 1])
							.'</div>';
					$_SESSION['dcp_current_id_coupon_user_sse'] = 0;
				   }
				}
			return $html_notices;
		}

    /**
     *  Header formation.
     *
     *  @param  int $id_coupon
     *  @return string
     */
		private static function html_headline($id_coupon) {
				$notices_options['sse_ncp_div_headline_rules_css'] = WC_Admin_Settings::get_option('sse_ncp_div_headline_rules_css');
				$notices_options['sse_ncp_div_headline_code_css'] = WC_Admin_Settings::get_option('sse_ncp_div_headline_code_css');
				$notices_options['sse_ncp_div_headline_padding_tb'] = WC_Admin_Settings::get_option('sse_ncp_div_headline_padding_tb');
				$notices_options['sse_ncp_div_headline_padding_rl'] = WC_Admin_Settings::get_option('sse_ncp_div_headline_padding_rl');
				$notices_options['sse_ncp_div_headline_horiz_alignm'] = WC_Admin_Settings::get_option('sse_ncp_div_headline_horiz_alignm');
				$notices_options['sse_ncp_div_headline_col'] = WC_Admin_Settings::get_option('sse_ncp_div_headline_col');
				$notices_options['sse_ncp_div_headline_height'] = WC_Admin_Settings::get_option('sse_ncp_div_headline_height');
				$notices_options['sse_ncp_headline_rules_css'] = WC_Admin_Settings::get_option('sse_ncp_headline_rules_css');
				$notices_options['sse_ncp_headline_code_css'] = WC_Admin_Settings::get_option('sse_ncp_headline_code_css');
				$notices_options['sse_ncp_headline_width'] = WC_Admin_Settings::get_option('sse_ncp_headline_width');
				$notices_options['sse_ncp_headline_col_font'] = WC_Admin_Settings::get_option('sse_ncp_headline_col_font');
				$notices_options['sse_ncp_headline_font_size'] = WC_Admin_Settings::get_option('sse_ncp_headline_font_size');

				if (WC_Admin_Settings::get_option('sse_ncp_headline_text') !='') {
					$notices_options['sse_ncp_headline_text'] = WC_Admin_Settings::get_option('sse_ncp_headline_text');
				}else{
					$notices_options['sse_ncp_headline_text'] = 'Notification of a new coupon';
				}

			if($notices_options['sse_ncp_div_headline_rules_css']=='yes'){
				$html_div_headline ='<div '
								. 'class="sse_ncp_head_'. (int) $id_coupon .'" '
								. 'style="'
								. $notices_options['sse_ncp_div_headline_code_css']
								. '">';
			}else{
				$html_div_headline ='<div '
								. 'class="sse_ncp_head_'. (int) $id_coupon .'" '
								. 'style="widtx:100%; '
								. 'padding: ' . $notices_options['sse_ncp_div_headline_padding_tb'] . 'px '
									. $notices_options['sse_ncp_div_headline_padding_rl'] . 'px; '
								. 'margin: 0 0 0 0; '
								. 'text-align: ' . $notices_options['sse_ncp_div_headline_horiz_alignm']. '; '
								. 'background-color: ' . $notices_options['sse_ncp_div_headline_col'] . '; '
								. 'height: ' . $notices_options['sse_ncp_div_headline_height'] .'px; '
								. '">';
			}

			if($notices_options['sse_ncp_headline_rules_css']=='yes'){
				$html_headline =$html_div_headline
								. '<div '
								. 'style="'
								. $notices_options['sse_ncp_headline_code_css']
								. '">'
									. do_shortcode(wpautop(wptexturize($notices_options['sse_ncp_headline_text'])))
								. '</div>'
							. '</div>';
			}else{
				$html_headline =$html_div_headline
                  . '<div '
                  . 'style="'
                  . 'display: inline-block; '
                  . 'padding: 0 0 0 0; '
                  . 'margin: 0 0 0 0; '
                  . 'width: ' . $notices_options['sse_ncp_headline_width'] .'%; '
                  . 'color: ' . $notices_options['sse_ncp_headline_col_font'] .'; '
                  . 'font-size: ' . $notices_options['sse_ncp_headline_font_size'] .'px; '
                  . '">'
                    . do_shortcode(wpautop(wptexturize($notices_options['sse_ncp_headline_text'])))

                  . '</div>'
							. '</div>';
			}
			return $html_headline;
		}

        /**
         *  Formation of the delete button.
         *
         *  @param  int $id_coupon
         *  @return string
         */
		private static function html_button_del($id_coupon) {
			$notices_options['sse_div_rules_del_css'] = WC_Admin_Settings::get_option('sse_div_rules_del_css');
			$notices_options['sse_div_del_code_css'] = WC_Admin_Settings::get_option('sse_div_del_code_css');
			$notices_options['sse_n_div_del_margin'] = WC_Admin_Settings::get_option('sse_n_div_del_margin');
			$notices_options['sse_del_horiz_alignm'] = WC_Admin_Settings::get_option('sse_del_horiz_alignm');
			$notices_options['sse_button_rules_del_css'] = WC_Admin_Settings::get_option('sse_button_rules_del_css');
			$notices_options['sse_button_del_code_css'] = WC_Admin_Settings::get_option('sse_button_del_code_css');
			$notices_options['sse_n_button_del_col'] = WC_Admin_Settings::get_option('sse_n_button_del_col');
			$notices_options['sse_n_button_del_width'] = WC_Admin_Settings::get_option('sse_n_button_del_width');
			$notices_options['sse_n_button_del_height'] = WC_Admin_Settings::get_option('sse_n_button_del_height');
			$notices_options['sse_n_button_del_col_font'] = WC_Admin_Settings::get_option('sse_n_button_del_col_font');
			$notices_options['sse_but_del_font_size'] = WC_Admin_Settings::get_option('sse_but_del_font_size');

      if (WC_Admin_Settings::get_option('sse_ncp_button_del_text') !='') {
					$notices_options['sse_ncp_button_del_text'] = WC_Admin_Settings::get_option('sse_ncp_button_del_text');
				}else{
					$notices_options['sse_ncp_button_del_text'] = 'DEL';
				}

			if($notices_options['sse_div_rules_del_css']=='yes'){
				$html_div_del ='<div '
								. 'style="'
								. $notices_options['sse_div_del_code_css']
								. '">';
			}else{
				$html_div_del ='<div '
								. 'style="widtx:100%; '
								. 'clear: both; '
								. 'margin-top: ' . $notices_options['sse_n_div_del_margin'] .'px; '
								. 'text-align: ' . $notices_options['sse_del_horiz_alignm']. '; '
								. '">';
			}

			if($notices_options['sse_button_rules_del_css']=='yes'){
				$html_button_del =$html_div_del
								. '<p class="submit" '
								. 'style="'
								. 'padding: 0 0 0 0; '
								. 'margin: 0 0 0 0; '
								. '">'
									. '<button '
										. 'class="sse_notices_button_del" '
										. 'style="'
										. $notices_options['sse_button_del_code_css']
										. '"'
										. 'data-id-coupon="' . (int) $id_coupon
										. '" '
										. self::js_button_del() . '>'
										. do_shortcode(wpautop(wptexturize($notices_options['sse_ncp_button_del_text'])))
									. '</button>'
								. '</p>'
							. '</div>';
			}else{
				$html_button_del =$html_div_del
								. '<p class="submit" '
								. 'style="'
								. 'padding: 0 0 0 0; '
								. 'margin: 0 0 0 0; '
								. '">'
									. '<button '
										. 'class="sse_notices_button_del" '
										. 'style="'
										. 'outline: none; '
										. 'line-height: ' . $notices_options['sse_n_button_del_height'] .'px; '
										. 'padding: 0 0 0 0; '
										. 'text-align: center; '
										. 'margin: 0 0 0 0; '
										. 'background-color: ' . $notices_options['sse_n_button_del_col'] . '; '
										. 'width: ' . $notices_options['sse_n_button_del_width'] .'px; '
										. 'height: ' . $notices_options['sse_n_button_del_height'] .'px; '
										. 'color: ' . $notices_options['sse_n_button_del_col_font'] .'; '
										. 'font-size: ' . $notices_options['sse_but_del_font_size'] .'px; '
										. '"'
										. 'data-id-coupon="' . (int) $id_coupon
										. '" '
										. self::js_button_del() . '>'
										. do_shortcode(wpautop(wptexturize($notices_options['sse_ncp_button_del_text'])))
									. '</button>'
								. '</p>'
							. '</div>';
			}
			return $html_button_del;
		}


        /**
         *  The js code of the delete button.
         *
         *  @return string
         */
		private static function js_button_del() {
			$notices_options['sse_button_rules_del_css'] = WC_Admin_Settings::get_option('sse_button_rules_del_css');
			$notices_options['sse_button_del_js'] = WC_Admin_Settings::get_option('sse_button_del_js');
			$notices_options['sse_n_button_del_col'] = WC_Admin_Settings::get_option('sse_n_button_del_col');
			$notices_options['sse_n_hover_button_del_col'] = WC_Admin_Settings::get_option('sse_n_hover_button_del_col');

			$js_button_del = "";
			if ($notices_options['sse_button_del_js'] == "yes" || $notices_options['sse_button_rules_del_css'] == "no") {
				if (1 == preg_match('/^[a-zA-Z0-9]+$/', substr($notices_options['sse_n_button_del_col'], 1)) &&
						1 == preg_match('/^[a-zA-Z0-9]+$/', substr($notices_options['sse_n_hover_button_del_col'], 1))) {
					$js_button_del = 'onmouseout="this.style.backgroundColor=\'' . $notices_options['sse_n_button_del_col'] .
							'\';" onmouseover="this.style.backgroundColor=\'' . $notices_options['sse_n_hover_button_del_col'] . '\';"';
				}
			}
			return $js_button_del;
		}

        /**
         *  The formation of the previous button.
         *
         *  @param  int $end_point
         *  @return string
         */
		private static function html_button_next($end_point) {
			$notices_options['sse_div_rules_next_css'] = WC_Admin_Settings::get_option('sse_div_rules_next_css');
			$notices_options['sse_div_next_code_css'] = WC_Admin_Settings::get_option('sse_div_next_code_css');
			$notices_options['sse_n_div_next_margin'] = WC_Admin_Settings::get_option('sse_n_div_next_margin');
			$notices_options['sse_next_horiz_alignm'] = WC_Admin_Settings::get_option('sse_next_horiz_alignm');
			$notices_options['sse_button_rules_next_css'] = WC_Admin_Settings::get_option('sse_button_rules_next_css');
			$notices_options['sse_button_next_code_css'] = WC_Admin_Settings::get_option('sse_button_next_code_css');
			$notices_options['sse_n_button_next_col'] = WC_Admin_Settings::get_option('sse_n_button_next_col');
			$notices_options['sse_n_button_next_width'] = WC_Admin_Settings::get_option('sse_n_button_next_width');
			$notices_options['sse_n_button_next_height'] = WC_Admin_Settings::get_option('sse_n_button_next_height');
			$notices_options['sse_n_button_next_col_font'] = WC_Admin_Settings::get_option('sse_n_button_next_col_font');
			$notices_options['sse_but_next_font_size'] = WC_Admin_Settings::get_option('sse_but_next_font_size');

      if (WC_Admin_Settings::get_option('sse_ncp_button_next_text') !='') {
					$notices_options['sse_ncp_button_next_text'] = WC_Admin_Settings::get_option('sse_ncp_button_next_text');
				}else{
					$notices_options['sse_ncp_button_next_text'] = 'DEL';
				}

			if($notices_options['sse_div_rules_next_css']=='yes'){
				$html_div_next ='<div '
								. 'class="sse_notices_div_next" '
								. 'style="'
								. $notices_options['sse_div_next_code_css']
								. '">';
			}else{
				$html_div_next ='<div '
								. 'class="sse_notices_div_next" '
								. 'style="widtx:100%; '
								. 'margin-top: ' . $notices_options['sse_n_div_next_margin'] .'px; '
								. 'text-align: ' . $notices_options['sse_next_horiz_alignm']. '; '
								. '">';
			}

			if($notices_options['sse_button_rules_next_css']=='yes'){
				$html_button_next = $html_div_next
								. '<p class="submit" '
								. 'style="'
								. 'padding: 0 0 0 0; '
								. 'margin: 0 0 0 0; '
								. '">'
									. '<button '
										. 'class="sse_notices_button_next" '
										. 'style="'
										. $notices_options['sse_button_next_code_css']
										. '"'
										. 'data-id-coupon="' . (int) $end_point
										. '" '
										. self::js_button_next() . '>'
                      . do_shortcode(wpautop(wptexturize($notices_options['sse_ncp_button_next_text'])))
									. '</button>'
								. '</p>'
							. '</div>';
			}else{
				$html_button_next = $html_div_next
								. '<p class="submit" '
								. 'style="'
								. 'padding: 0 0 0 0; '
								. 'margin: 0 0 0 0; '
								. '">'
									. '<button '
										. 'class="sse_notices_button_next" '
										. 'style="'
										. 'outline: none; '
										. 'line-height: ' . $notices_options['sse_n_button_next_height'] .'px; '
										. 'padding: 0 0 0 0; '
										. 'text-align: center; '
										. 'margin: 0 0 0 0; '
										. 'background-color: ' . $notices_options['sse_n_button_next_col'] . '; '
										. 'width: ' . $notices_options['sse_n_button_next_width'] .'px; '
										. 'height: ' . $notices_options['sse_n_button_next_height'] .'px; '
										. 'color: ' . $notices_options['sse_n_button_next_col_font'] .'; '
										. 'font-size: ' . $notices_options['sse_but_next_font_size'] .'px; '
										. '"'
										. 'data-id-coupon="' . (int) $end_point
										. '" '
										. self::js_button_next() . '>'
										  . do_shortcode(wpautop(wptexturize($notices_options['sse_ncp_button_next_text'])))
									. '</button>'
								. '</p>'
							. '</div>';
			}
			return $html_button_next;
		}

        /**
         *  The js code of the previous button.
         *
         *  @return string
         */
		private static function js_button_next() {
			$notices_options['sse_button_rules_next_css'] = WC_Admin_Settings::get_option('sse_button_rules_next_css');
			$notices_options['sse_button_rules_next_js'] = WC_Admin_Settings::get_option('sse_button_rules_next_js');
			$notices_options['sse_n_button_next_col'] = WC_Admin_Settings::get_option('sse_n_button_next_col');
			$notices_options['sse_n_hover_button_next_col'] = WC_Admin_Settings::get_option('sse_n_hover_button_next_col');

			$js_button_next = "";
			if ($notices_options['sse_button_rules_next_js'] == "yes" || $notices_options['sse_button_rules_next_css'] == "no") {
				if (1 == preg_match('/^[a-zA-Z0-9]+$/', substr($notices_options['sse_n_button_next_col'], 1)) &&
						1 == preg_match('/^[a-zA-Z0-9]+$/', substr($notices_options['sse_n_hover_button_next_col'], 1))) {
					$js_button_next = 'onmouseout="this.style.backgroundColor=\'' . $notices_options['sse_n_button_next_col'] .
							'\';" onmouseover="this.style.backgroundColor=\'' . $notices_options['sse_n_hover_button_next_col'] . '\';"';
				}
			}
			return $js_button_next;
		}

}